const pages = [
    {
        title: 'sol-compiler',
        filename: 'compiler/index.html',
        template: 'assets/index.html',
        chunks: ['compiler'],
        favicon: 'assets/favicons/compiler.ico',
        minify: true,
        meta: {
            description: 'Solidity compilation that just works',
            'og-title': { property: 'og:title', content: 'sol-compiler' },
            'og-description': { property: 'og:description', content: 'Solidity compilation that just works' },
            'og-type': { property: 'og:type', content: 'website' },
            'og-image': { property: 'og:image', content: '/images/og-compiler.png' },
            'twitter:site': '@0xproject',
            'twitter:image': '/images/og-compiler.png',
        },
        googleAnalyticsId: 'UA-98720122-4',
        heapAnalyticsId: '3772819976',
    },
    {
        title: 'sol-coverage',
        filename: 'coverage/index.html',
        template: 'assets/index.html',
        chunks: ['coverage'],
        favicon: 'assets/favicons/cov.ico',
        minify: true,
        meta: {
            description: 'Solidity code coverage',
            'og-title': { property: 'og:title', content: 'sol-coverage' },
            'og-description': { property: 'og:description', content: 'Solidity code coverage' },
            'og-type': { property: 'og:type', content: 'website' },
            'og-image': { property: 'og:image', content: '/images/og-cov.png' },
            'twitter:site': '@0xproject',
            'twitter:image': '/images/og-cov.png',
        },
        googleAnalyticsId: 'UA-98720122-3',
        heapAnalyticsId: '3386971671',
    },
    {
        title: 'sol-profiler',
        filename: 'profiler/index.html',
        template: 'assets/index.html',
        chunks: ['profiler'],
        favicon: 'assets/favicons/profiler.ico',
        minify: true,
        meta: {
            description: 'Gas profiling for Solidity',
            'og-title': { property: 'og:title', content: 'sol-profiler' },
            'og-description': { property: 'og:description', content: 'Gas profiling for Solidity' },
            'og-type': { property: 'og:type', content: 'website' },
            'og-image': { property: 'og:image', content: '/images/og-profiler.png' },
            'twitter:site': '@0xproject',
            'twitter:image': '/images/og-profiler.png',
        },
        googleAnalyticsId: 'UA-98720122-5',
        heapAnalyticsId: '3776009943',
    },
    {
        title: 'sol-trace',
        filename: 'trace/index.html',
        template: 'assets/index.html',
        chunks: ['trace'],
        favicon: 'assets/favicons/trace.ico',
        minify: true,
        meta: {
            description: 'Human-readable stack traces',
            'og-title': { property: 'og:title', content: 'sol-trace' },
            'og-description': { property: 'og:description', content: 'Human-readable stack traces' },
            'og-type': { property: 'og:type', content: 'website' },
            'og-image': { property: 'og:image', content: '/images/og-trace.png' },
            'twitter:site': '@0xproject',
            'twitter:image': '/images/og-trace.png',
        },
        googleAnalyticsId: 'UA-98720122-6',
        heapAnalyticsId: '4172106583',
    },
];

module.exports = pages;
